<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1">

    <title>Beacons</title>

    <link rel="stylesheet" href="/en/latest/css/core.css">
    <link rel="stylesheet" href="/en/latest/css/getstarted.css">
    <link rel="shortcut icon" href="/en/latest/css/images/saltStack_favIcon_32x32.png">

</head>
<body>

<nav id="globalNavbar" class="navbar navbar-default navbar-inverse navbar-fixed-top" role="navigation">
    <!-- Brand and toggle get grouped for better mobile display -->
    <div class="container">
        <div class="navbar-header">
            <button type="button" class="navbar-toggle" data-toggle="collapse" data-target="#navbarCollapse">
                <span class="sr-only">Toggle navigation</span>
                <span class="icon-bar"></span>
                <span class="icon-bar"></span>
                <span class="icon-bar"></span>
            </button>
            <a href="http://saltstack.com/" target="_blank"><img src="/en/latest/css/images/saltstack.svg" height="40px" width="170px" class="nolightbox"></a>
        </div>
        <!-- Collect the nav links, forms, and other content for toggling -->
        <div class="collapse navbar-collapse" id="navbarCollapse">
            <ul class="nav navbar-nav">
                <li><a href="/en/latest/">Overview</a></li>
                <li><a href="/en/getstarted/">Tutorials</a></li>
                <li><a href="/en/latest/contents.html">Documentation</a></li>
                <li><a href="https://repo.saltstack.com">Downloads</a></li>
                <li><a href="/en/latest/topics/development/">Develop</a></li>
            </ul>
        </div>
    </div>
</nav>

<div class="jumbotron">

    <div class="row row-centered">
        <div class="col-md-9 col-centered">
            <h1>Event-Driven Infrastructure</h1>

            <h3>Get Started Tutorial</h3>

        </div>
    </div>
    <!--<div class="gs-top-nav">
        <a href="/en/getstarted/getstarted/index.html">Back to Get Started <i class="glyphicon glyphicon-arrow-left"></i></a><br>
        <a href="/en/getstarted">Back to Documentation <i class="glyphicon glyphicon-arrow-left"></i></a>
    </div>-->
</div>







<div class="container">
    <div class="row">
        <div class="col-md-12">
            <ol class="progtrckr" data-progtrckr-steps="5">
                
                
                
                <li class="progtrckr-done">
                    
                    <a href="/en/getstarted/event/index.html">Event-Driven Infrastructure</a>
                </li>
                
                
                
                
                <li class="progtrckr-done">
                    
                    <a href="/en/getstarted/event/events.html">Watching Events</a>
                </li>
                
                
                
                
                <li class="progtrckr-done">
                    
                    <a href="/en/getstarted/event/custom.html">Custom Events</a>
                </li>
                
                
                
                <li class="progtrckr-done">Beacons</li>
                
                
                
                
                
                
                
                
                
                
                
                
                
                <li class="progtrckr-todo">
                    
                    <a href="/en/getstarted/event/reactor.html">Event Reactor</a>
                </li>
                
                
            </ol>
        </div>
    </div>

    <div class="row">
        <div class="col-md-1"></div>
        <div class="col-md-10">

            

            <h1>Beacons</h1>

            <div class="section gs-overview">

                
                <p class="p gs-overview-sub"><span class="ph">You'll learn how to:</span></p>

                <ul class="ul">
                    
                    <li class="progtrckr-done">Understand Salt beacons</li>
                    
                    <li class="progtrckr-done">Use a Salt beacon to monitor a file or system process</li>
                    
                </ul>
                

                
                <p class="p gs-overview-sub gs-time"><span class="ph">
                              Estimated time: 10 minutes</span>&nbsp;<i
                        class="glyphicon glyphicon-time"></i>
                </p>
                

                
                <p class="p gs-overview-sub gs-difficulty-1"><span class="ph">Difficulty</span>:&nbsp;
                    
                    
                    <i class="glyphicon glyphicon-cog"></i>
                    
                    
                    
                    <i class="glyphicon glyphicon-cog"></i>
                    
                    
                    
                    <i class="glyphicon glyphicon-cog lighter"></i>
                    
                    
                    
                    <i class="glyphicon glyphicon-cog lighter"></i>
                    
                    
                    
                    <i class="glyphicon glyphicon-cog lighter"></i>
                    
                    
                </p>
                
            </div>
            

            <p>So far we’ve learned how to monitor the event bus for Salt-related events, and how to enable a few additional events. At this point you might be thinking <em>“Since I’ve already set up a dynamic communication infrastructure that can monitor and react to Salt events in real-time, it would sure be swell if I could use that system to also monitor other things such as system logins, disk usage, and my database service.”</em> (OK, maybe not quite in those words).</p>
<p>Those words or not, you are in luck, since that is <em>exactly</em> what beacons do!</p>
<p>Beacons let you monitor and raise events for things that are not Salt-related. The beacon system allows the minion to hook into a variety of system processes and continually monitor these processes. When monitored activity occurs in a system process, an event is sent on the Salt event bus.</p>
<p>Salt beacons can currently monitor and send Salt events for many system activities, including:</p>
<ul>
<li>file system changes</li>
<li>system load</li>
<li>service status</li>
<li>shell activity, such as user login</li>
<li>network and disk usage</li>
</ul>
<h2 id="enable-a-beacon">Enable a Beacon</h2>
<p>Salt beacons do not require any changes to the system process that is being monitored, everything is configured using Salt.</p>
<p>Beacons are typically enabled by placing a top-level <code>beacons</code> section in the minion configuration file:</p>
<pre class="language-yaml"><code class="language-yaml"><span class="fu">beacons:</span>
  <span class="fu">inotify:</span>
    <span class="fu">home/user/importantfile:</span>
      <span class="fu">mask:</span>
        <span class="kw">-</span> modify</code></pre>
<h3 id="beacon-monitoring-interval">Beacon Monitoring Interval</h3>
<div class="section sidebar">
<h4 id="avoiding-event-loops">Avoiding Event Loops</h4>
<p>If a beacon reactor might make a change that would re-trigger the beacon, add and set the <code>disable_during_state_run</code> argument to <code>True</code>.</p>
<pre class="language-yaml"><code class="language-yaml"><span class="fu">beacons:</span>
  <span class="fu">inotify:</span>
    <span class="fu">home/user/importantfile:</span>
      <span class="fu">mask:</span>
        <span class="kw">-</span> modify
    <span class="fu">disable_during_state_run:</span> True </code></pre>
<p>As with most loop conditions, you’ll probably find out the hard way when you need to add this.</p>
</div>
<p>Beacons monitor on a 1-second interval by default. To set a different interval, provide an interval argument to a beacon. The following beacons run on 5- and 10-second intervals:</p>
<pre class="language-bash"><code class="language-bash"><span class="kw">beacons</span>:
  <span class="kw">inotify</span>:
    <span class="kw">/etc/httpd</span>/conf.d: <span class="dt">{}</span>
    /opt: <span class="dt">{}</span>
    <span class="kw">interval</span>: 5
  <span class="kw">load</span>:
    <span class="kw">-</span> 1m:
      <span class="kw">-</span> 0.0
      <span class="kw">-</span> 2.0
    <span class="kw">-</span> 5m:
      <span class="kw">-</span> 0.0
      <span class="kw">-</span> 1.5
    <span class="kw">-</span> 15m:
      <span class="kw">-</span> 0.1
      <span class="kw">-</span> 1.0
    <span class="kw">-</span> interval: 10</code></pre>
<p>After a beacon is configured, it triggers events just like any other Salt process.</p>
<h2 id="adding-a-beacon">Adding a Beacon</h2>
<p>We are going to add a beacon that watches for changes to a file. To do this, we’ll use the <a href="https://docs.saltstack.com/en/latest/ref/beacons/all/salt.beacons.inotify.html">inotify</a> beacon and the <code>python-pyinotify</code> package. Since this package isn’t on our Salt minions, first we’ll use Salt to install it.</p>
<h3 id="install-pyinotify-and-start-the-event-runner">Install pyinotify and start the event runner</h3>
<p>Open a command prompt to the <code>salt-vagrant-demo</code> directory, and ssh into <code>master</code>:</p>
<pre class="language-bash"><code class="language-bash"><span class="kw">vagrant</span> ssh master</code></pre>
<p>Install the <code>python-pyinotify</code> package on <code>minion1</code>:</p>
<pre class="language-bash"><code class="language-bash"><span class="kw">sudo</span> salt <span class="st">&#39;minion1&#39;</span> pkg.install python-pyinotify</code></pre>
<p>You should see output similar to the following:</p>
<pre class="language-bash"><code class="language-bash"><span class="kw">vagrant@saltmaster</span>:~$ sudo salt <span class="st">&#39;minion1&#39;</span> pkg.install python-pyinotify
<span class="kw">minion1</span>:
    <span class="kw">----------</span>
    <span class="kw">python-pyinotify</span>:
        <span class="kw">----------</span>
        <span class="kw">new</span>:
            <span class="kw">0.9.4-1build1</span>
        <span class="kw">old</span>:
    <span class="kw">python2.7-pyinotify</span>:
        <span class="kw">----------</span>
        <span class="kw">new</span>:
            <span class="kw">1</span>
        <span class="kw">old</span>:</code></pre>
<p>Since we’ll be generating an event shortly, remain logged in to your Salt master and start the event runner:</p>
<pre class="language-bash"><code class="language-bash"><span class="kw">salt-run</span> state.event pretty=True</code></pre>
<p>Leave that running in the terminal and continue.</p>
<h3 id="set-up-a-beacon">Set up a beacon</h3>
<p>Open another command prompt to the <code>salt-vagrant-demo</code> directory, and ssh into <code>minion1</code>:</p>
<pre class="language-bash"><code class="language-bash"><span class="kw">vagrant</span> ssh minion1</code></pre>
<p>On <code>minion1</code>, edit the <code>/etc/salt/minion</code> file and add the following content at the bottom:</p>
<pre class="language-yaml"><code class="language-yaml"><span class="fu">beacons:</span>
  <span class="fu">inotify:</span>
    <span class="fu">/home/vagrant/importantfile:</span>
      <span class="fu">mask:</span>
        <span class="kw">-</span> modify</code></pre>
<p>Save the file, and then restart the Salt minion service:</p>
<pre class="language-bash"><code class="language-bash"><span class="kw">sudo</span> service salt-minion restart</code></pre>
<p>The beacon is now saved and enabled. Next, we can create the file that we are going to monitor for changes. In the <code>/home/vagrant/</code> directory, create <code>importantfile</code>:</p>
<pre class="language-bash"><code class="language-bash"><span class="kw">touch</span> importantfile
<span class="kw">echo</span> <span class="st">&quot;some content&quot;</span> <span class="kw">&gt;</span> importantfile</code></pre>
<p>Back on your Salt master, you should have picked up an event similar to the following:</p>
<pre class="language-bash"><code class="language-bash"><span class="kw">salt/beacon/minion1/inotify//home/vagrant/importantfile</span> {
    <span class="st">&quot;_stamp&quot;</span>: <span class="st">&quot;2016-02-03T22:32:09.592113&quot;</span>,
    <span class="st">&quot;data&quot;</span>: <span class="kw">{</span>
        <span class="st">&quot;change&quot;</span>: <span class="st">&quot;IN_MODIFY&quot;</span>,
        <span class="st">&quot;id&quot;</span>: <span class="st">&quot;minion1&quot;</span>,
        <span class="st">&quot;path&quot;</span>: <span class="st">&quot;/home/vagrant/importantfile&quot;</span>
    <span class="kw">}</span>,
    <span class="st">&quot;tag&quot;</span>: <span class="st">&quot;salt/beacon/minion1/inotify//home/vagrant/importantfile&quot;</span>
}</code></pre>
<p>Remember that the event runner must be started before the file is modified or you won’t see the event (the event will still be triggered, you just won’t see it).</p>
<p>Now that we’ve got a beacon working and are generating other Salt events, it’s time to do something with these events using the Salt reactor.</p>


            <br>
            
            <a href="/en/getstarted/event/custom.html">
                <button type="button" class="btn btn-secondary"><span
                        class="glyphicon glyphicon-chevron-left"></span> Previous
                </button>
            </a>
            

            
            <a href="/en/getstarted/event/reactor.html">
                <button type="button" class="btn btn-primary btn-right">
                    Next <span class="glyphicon glyphicon-chevron-right"></span></button>
            </a>
            

        </div>
        <div class="col-md-1"></div>
    </div>
    <div class="footer">
  <p>© 2020 SaltStack. All Rights Reserved, SaltStack Inc. | <a href="http://saltstack.com/privacy-policy" target="_blank">Privacy Policy</a></p>
</div>
</div>

<script type="text/javascript" src="/en/latest/js/core-min.js"></script>



<!--analytics-->
<script type="text/javascript">llactid=23943</script>
<script type="text/javascript" src="https://trackalyzer.com/trackalyze_secure.js"></script>

<script>
          var _gaq = _gaq || [];
          var pluginUrl = '//www.google-analytics.com/plugins/ga/inpage_linkid.js';
          _gaq.push(['_require', 'inpage_linkid', pluginUrl]);
          _gaq.push(['_setAccount', 'UA-26984928-1']);
          _gaq.push(['_setDomainName', 'saltstack.com']);
          _gaq.push(['_trackPageview']);

          (function() {
              var ga = document.createElement('script'); ga.type = 'text/javascript'; ga.async = true;
              ga.src = ('https:' == document.location.protocol ? 'https://ssl' : 'http://www') + '.google-analytics.com/ga.js';
              var s = document.getElementsByTagName('script')[0]; s.parentNode.insertBefore(ga, s);
          })();

</script>

</body>
</html>